----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:28:24 01/07/2013 
-- Design Name: 
-- Module Name:    mem_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library work;
use work.top_pkg.all;

entity mem_ctrl is
	 port (
		clk     : in std_logic ;
		reset   : in std_logic ;
		dout_en : out std_logic;
		din     : in std_logic_vector(2 downto 0);
	   dout    : out std_logic_vector(2 downto 0) );
end mem_ctrl;

architecture Behavioral of mem_ctrl is
	signal delay : std_logic;

	constant FACTOR : integer := 10 -1;    -- Teilfaktor
   signal divider  : integer range 0 to FACTOR;
   signal load     : std_logic;
begin

process(clk)
begin
	if rising_edge(clk) then
		if reset = '1' then
			dout <= (others => '0');
			dout_en <= '0';
		else
			-- insert more logic here
			dout <= (others => '1');
			dout_en <= '0';
			if delay = '1' then
				dout_en <= '1';
			end if;
		end if;
	end if;
end process;

-----------
-- Testfunktion um das dout_en ein wenig arbeiten zu lassen 
-- (damit es nicht wegoptimiert wird)  
  clockgen : process (clk)
  begin
    if rising_edge(clk) then
      if reset = '1' then
        divider <= FACTOR;
      else
        if load = '1' then
          divider <= FACTOR;
        else
          divider <= divider - 1;
        end if;
      end if;
    end if;
  end process;

  -- geteilten Clock erzeugen
  load <= '1' when divider = 0 else '0';

  -- Output
  delay <= load;


end Behavioral;

