----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:49:17 01/07/2013 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;
library work;
use work.top_pkg.all;

  entity top is
	port (
	   clk     : in std_logic;
		rst     : in std_logic;
		data    : inout std_logic_vector(2 downto 0)
	);
  end top;
  
architecture Behavioral of top is
	signal dout : std_logic_vector(2 downto 0);
	signal din  : std_logic_vector(2 downto 0);
	signal dout_en : std_logic;

  -- Memory controller
	component mem_ctrl 
	 port (
		clk   : in std_logic ;
		reset : in std_logic ;
		dout_en: out std_logic;
		din   : in std_logic_vector(2 downto 0);
	   dout  : out std_logic_vector(2 downto 0) 
		);
	end component;

begin

  -- instantiate memory controller
	mem_ctrl_i : mem_ctrl
		port map (
			clk => clk,
			reset => rst,
			dout_en => dout_en,
			din => din,
			dout => dout
		);
		
		-- drive data out
		data <= dout when dout_en = '1' else (others => 'Z');
		-- read data in
		din <= data(2 downto 0);
  

end Behavioral;
